/* https://n-e-r-v-o-u-s.com/tools/obj/
Jesse Louis-Rosenberg, Nervous System jesse@n-e-r-v-o-u-s.com
Contributor: Michael Zoellner
messed with by wendy Nov 2018 for fabricademy
*/
import nervoussystem.obj.*; //the library that we will be calling 

boolean record = false;
float noiseScale = .05; //declare variable and its value
void setup() {
  size(800,800,P3D); // size of window, changed it to be bigger
}

void draw() {
  background(200); //made the background grey instead of white
  
  if(record) {
    //X3DExport x3d = (X3DExport) createGraphics(10,10,"nervoussystem.obj.X3DExport","colored.x3d");
    OBJExport obj = (OBJExport) createGraphics(10,10,"nervoussystem.obj.OBJExport","coloredscale.obj"); //added a number variable to the file name
    obj.setColor(true);
    obj.beginDraw();
    drawNoise(obj);
    obj.endDraw();
    obj.dispose();
    record = false;
  }
  noStroke();
  translate(width/2,height/2,-50);
  rotateX(PI/6.0);
  rotateZ(frameCount*PI/360.0);
  translate(-100,-100,0); //rotational positioning
  scale(8); //scale of object in window,//increased scale from 6 to 8
  drawNoise(this.g);
}

void drawNoise(PGraphics pg) {
  pg.beginShape(TRIANGLES);
  for(int i=0;i<50;i++) {
    for(int j=0;j<50;j++) {
      float z = noise(i*noiseScale,j*noiseScale);
      pg.fill( lerpColor( color(25,0,255),color(0,0,255),z ));//changed colour from 255,0,0 to 25,0,255
      pg.vertex(i,j,z*50);
      z = noise((i+1)*noiseScale,j*noiseScale);
      pg.fill( lerpColor( color(255,0,0),color(0,0,255),z ));
      pg.vertex(i+1,j,z*50);
      z = noise((i+1)*noiseScale,(j+1)*noiseScale);
      pg.fill( lerpColor( color(105,0,255),color(0,0,255),z ));//changed colour from 255,0,0 to 105,0,255
      pg.vertex(i+1,j+1,z*50);

      z = noise((i+1)*noiseScale,(j+1)*noiseScale);
      pg.fill( lerpColor( color(255,255,0),color(0,255,255),z ));//changed colour from 255,0,0 and 0,0,255 to 255,255,0 and 0,255,255 in two places
      pg.vertex(i+1,j+1,z*50);
      z = noise(i*noiseScale,(j+1)*noiseScale);
      pg.fill( lerpColor( color(255,0,0),color(0,0,255),z ));
      pg.vertex(i,j+1,z*50);
      z = noise(i*noiseScale,j*noiseScale);
      pg.fill( lerpColor( color(255,0,0),color(0,0,255),z ));
      pg.vertex(i,j,z*50);
    }
  }
  pg.endShape();  
}
void keyPressed()
{
  if (key == 'r') {
    record = true;
  }
}
